<?php
/**
 * @var WP_User $user
 */

use Mbl\Gamification\Rating;
use Mbl\Gamification\UserTasks;

$tasks = (new UserTasks($user->ID))->list();
$rating = (new Rating())->by_user($user);
?>
<div id="tableGamification" class="table-responsive" style="display: none">
    <table class="table table-bordered table-center" style="background: #f7f7f7;">
        <thead>
        <tr>
            <th>Место в рейтинге: <?= $rating['rank'] ?></th>
            <th>Доступно очков: <?= $rating['points'] ?></th>
        </tr>
        </thead>
    </table>
    <br>
    <table class="table table-hover table-bordered table-center">
        <thead class="mbs-header">
        <tr>
            <th>№</th>
            <th>Название задания</th>
            <th>Превью</th>
            <th>Очки</th>
            <th>Прогресс</th>
        </tr>
        </thead>
        <tbody>
        <?php foreach ($tasks as $ind => $task): $taskData = $task->toArray() ?>
            <tr>
                <td><?= $ind + 1 ?></td>
                <td><?= $taskData['name'] ?></td>
                <td>
                    <img width="20"
                         src="<?= MBLG_PLUGIN_URI ?>assets/images/stars/<?= $taskData['preview'] ?>.png"
                         alt="<?= $taskData['name'] ?>">
                </td>
                <td><?= $task->points() ?></td>
                <td class="mbs-progress-wrap">
                    <?php if ($task->progress() > 0): ?>
                    <span class="mbs-progress" style="width:<?= $task->progress() ?>%"></span><strong class="mbs-progress-num"><?php endif; ?>
                        <?= $task->progress() ?>%
                        <?php if ($task->progress() > 0): ?></strong><?php endif; ?>
                </td>
            </tr>
        <?php endforeach; ?>
        </tbody>
    </table>
</div>
