<?php

namespace Mbl\Statistics;

use WP_REST_Request;
use function register_rest_route;

add_action('rest_api_init', 'Mbl\Statistics\rest_api');
function rest_api()
{
    register_rest_route('mbs/v1', '/user/lessons', [
        'methods' => 'POST',
        'callback' => 'Mbl\Statistics\lessons_list',
        'permission_callback' => fn() => true
    ]);
}

function lessons_list(WP_REST_Request $request): array
{
    $userId = (int)$request->get_params()['userId'];
    $term = (int)$request->get_params()['termId'];
    return (new Lessons($userId, $term))->list();
}