<?php

namespace Mbl\Statistics;

use WP_User;

add_action('edit_user_profile', 'Mbl\Statistics\visits_table', 55);
function visits_table(WP_User $user)
{
    /*
    if (!in_array('customer', $user->roles)) {
        return;
    }
    */
    $visits = new Visit();
    $courses = new Courses($user);
    if (defined('MBLC_PLUGIN_VERSION')) {
        $certificates = certificatesList($user);
    } else {
        $certificates = [];
    }
    ?>
    <table class="form-table">
        <tbody>
        <tr>
            <th><h3>Статистика</h3></th>
            <td>
                <button id="mbsShow" class="button button-primary" type="button">
                    Показать статистику пользователя
                </button>
            </td>
        </tr>
        </tbody>
    </table>
    <div id="mbs-root" class="mbs-root" style="display: none">
        <div class="mbs-inner">

            <div class="mbs-top">
                <div class="mbs-title">
                    Статистика пользователя: <?= $user->user_login ?>
                </div>
                <button id="mbsClose" type="button">Закрыть <span class="dashicons dashicons-no-alt"></span></button>
            </div>
            <ul class="mbs-tabs">
                <li>
                    <button type="button" data-tab="#tableVisits"
                            class="mbs-tab mbs-tab--active">Посещение страниц
                    </button>
                </li>
                <li>
                    <button type="button" data-tab="#tableCourses"
                            class="mbs-tab">Прохождение курсов
                    </button>
                </li>
                <?php if (defined('MBLC_PLUGIN_VERSION') && !empty($certificates)): ?>
                    <li>
                        <button type="button" data-tab="#tableCertificates"
                                class="mbs-tab">Сертификаты
                        </button>
                    </li>
                <?php endif; ?>
                <?php if (defined('MBLG_VERSION')): ?>
                    <li>
                        <button type="button" data-tab="#tableGamification"
                                class="mbs-tab">Геймификация
                        </button>
                    </li>
                <?php endif; ?>

            </ul>
            <div class="table-visits table-responsive" id="tableVisits">
                <table class="table table-striped table-hover table-bordered">
                    <thead class="mbs-header">
                    <tr>
                        <th>Дата</th>
                        <th>Время</th>
                        <th>Заголовок</th>
                        <th>URL</th>
                        <th>IP</th>
                        <th>Страна</th>
                        <th>Браузер</th>
                        <th>ОС</th>
                        <th>Устройство</th>
                        <th>Визитов</th>
                    </tr>
                    </thead>
                    <tbody>
                    <?php foreach ($visits->userStat($user) as $item): ?>
                        <tr>
                            <td><?= date('d.m.Y', strtotime($item['datetime'])) ?></td>
                            <td><?= date('H:i:s', strtotime($item['datetime'])) ?></td>
                            <td><?= $item['title'] ?></td>
                            <td><a href="<?= esc_attr($item['url']) ?>" target="_blank">
                                    <?= urldecode($item['url']) ?>
                                </a></td>
                            <td><?= $item['ip'] ?></td>
                            <td><?= $item['country_name'] ?></td>
                            <td><?= $item['browser'] ?></td>
                            <td><?= $item['os'] ?></td>
                            <td><?= $item['device'] ?></td>
                            <td><?= $item['count'] ?></td>
                        </tr>
                    <?php endforeach; ?>
                    </tbody>
                </table>
            </div>
            <div class="table-responsive" id="tableCourses" style="display: none">
                <table class="mbs-course-table">
                    <thead class="mbs-header">
                    <tr>
                        <th style="width: 410px">Название</th>
                        <th>Прогресс</th>
                        <th>Доступ</th>
                        <th>Уровень доступа</th>
                        <th>Подробнее</th>
                    </tr>
                    </thead>
                    <?php foreach ($courses->list() as $item): ?>
                        <tr class="mbs-course" id="course-<?= $item['term']->term_id ?>"
                            data-id="<?= $item['term']->term_id ?>">
                            <td>
                                <a href="<?= esc_attr($item['link']) ?>" target="_blank"><?= $item['name'] ?></a>
                            </td>
                            <td class="mbs-progress-wrap">
                                <?php if ($item['progress'] > 0): ?>
                                    <span class="mbs-progress" style="width:<?= $item['progress'] ?>%"></span>
                                    <strong class="mbs-progress-num"><?= $item['progress'] ?>%</strong>
                                <?php else: ?>
                                    <?= $item['progress'] ?>%
                                <?php endif; ?>
                            </td>
                            <td><?php if ($item['availability'] === 'available'): ?>
                                    <span style="color: #00AD47;" class="dashicons dashicons-unlock"></span>
                                <?php elseif ($item['availability'] === 'partially'): ?>
                                    <span style="color: #ff9f09;" class="dashicons dashicons-unlock"></span>
                                <?php else: ?>
                                    <span style="color: #D32627;" class="dashicons dashicons-lock"></span>
                                <?php endif; ?>
                            </td>
                            <td><?= $item['levels'] ?: '—' ?></td>
                            <td>
                                <?php if ($item['availability'] !== 'no_available' || $item['progress'] > 0): ?>
                                    <button type="button" class="mbs-detail" data-id="<?= $item['term']->term_id ?>">
                                        <span class="dashicons"></span>
                                    </button>
                                <?php endif; ?>
                            </td>
                        </tr>
                        <tr style="display: none" id="lessons-loader-<?= $item['term']->term_id ?>">
                            <td colspan="5">
                                <div class="loader-ellipse">
                                    <span class="loader-ellipse__dot"></span>
                                    <span class="loader-ellipse__dot"></span>
                                    <span class="loader-ellipse__dot"></span>
                                    <span class="loader-ellipse__dot"></span>
                                </div>
                            </td>
                        </tr>
                        <tr class="mbs-lessons" id="lessons-course-<?= $item['term']->term_id ?>" style="display: none">
                            <td colspan="5" class="mbs-lessons__table-wrap">
                                <table class="mbs-lessons__table">
                                    <thead>
                                    <tr>
                                        <th>№ урока</th>
                                        <th>Название урока</th>
                                        <th>Видимость</th>
                                        <th>Доступ</th>
                                        <th>Статус урока</th>
                                        <th>Дата прохождения</th>
                                        <th>Статус задания</th>
                                        <th>Уровень доступа</th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                    <?php endforeach; ?>
                </table>
            </div>
            <?php if (defined('MBLC_PLUGIN_VERSION')) {
                include MBS_PLUGIN_PATH . '/admin/modules/certificates.php';
            } ?>
            <?php if (defined('MBLG_VERSION')) {
                include MBS_PLUGIN_PATH . '/admin/modules/gamification.php';
            } ?>
        </div>
    </div>
    <script>
        (function ($) {
            $('.mbs-tab').on('click', function (event) {
                event.preventDefault()
                if (!$(this).hasClass('mbs-tab--active')) {
                    let prev = $('.mbs-tab--active')
                    prev.removeClass('mbs-tab--active')
                    $(prev.data('tab')).hide()
                    $(this).addClass('mbs-tab--active')
                    $($(this).data('tab')).show()
                }
            })
            $('.mbs-course').on('click', '.mbs-detail', toggle)

            function toggle(event) {
                let root_id = `#course-${$(this).data('id')}`
                let id = `#lessons-course-${$(this).data('id')}`
                let loader_id = `#lessons-loader-${$(this).data('id')}`
                if ($(id).hasClass('mbs-courses-open')) {
                    $(id).removeClass('mbs-courses-open')
                    $(root_id).removeClass('mbs-courses-open')
                    $(id).hide()
                } else {
                    $(loader_id).show()
                    $(root_id).addClass('mbs-courses-open')
                    $(id).slideDown()
                    $.ajax({
                        url: '<?= rest_url() ?>mbs/v1/user/lessons',
                        method: 'POST',
                        data: {userId: <?= $user->ID ?>, termId: $(this).data('id')}
                    })
                        .done((data) => {
                            let html = data.reduce(function (carry, item) {
                                let color = '#000000';
                                if (item.homeworkStatus === 'На проверке') {
                                    color = '#ff9f09';
                                } else if (item.homeworkStatus === 'Отклонено') {
                                    color = '#D32627';
                                } else if (item.homeworkStatus === 'Выполнено') {
                                    color = '#00AD47';
                                }
                                let status = item.is_passed
                                    ? `<span style="color: #00AD47;">Пройден</span>`
                                    : `<span style="color: #D32627;">Не пройден</span>`;
                                carry += `<tr><td>${item.number}</td>`
                                    + `<td><a href="${item.link}" target="_blank">${item.name}</a></td>`
                                    + `<td><span class="dashicons dashicons-${item.is_visible ? 'visibility' : 'hidden'}"</span></td>`
                                    + `<td><span class="dashicons dashicons-${item.is_access ? 'unlock' : 'lock'}"</span></td>`
                                    + `<td>${status}</td>`
                                    + `<td>${item.date}</td><td style="color: ${color}">${item.homeworkStatus}</td>`
                                    + `<td>${item.accessLevels ? item.accessLevels : '—'}</td></tr>`
                                return carry
                            }, '')
                            $(id).find('tbody').html(html)
                            $(id).addClass('mbs-courses-open')
                        })
                        .fail(() => {
                            alert("error");
                        })
                        .always(() => {
                            $(loader_id).hide()
                        })
                }


            }

        })(jQuery);
    </script>
    <?php
}
